/* Tab mode: 0 */
/*
	Primitive polynomial for GF(32): 0x25  mode=0
	f(x) =  x^0 + x^2 + x^5
*/
/*********************************************************************/
/* Anti-log table                                                    */
/*********************************************************************/
unsigned gfalog[32] = {
/*    0 */ 0x0001,0x0002,0x0004,0x0008,0x0010,0x0005,0x000a,0x0014,
/*    8 */ 0x000d,0x001a,0x0011,0x0007,0x000e,0x001c,0x001d,0x001f,
/*   16 */ 0x001b,0x0013,0x0003,0x0006,0x000c,0x0018,0x0015,0x000f,
/*   24 */ 0x001e,0x0019,0x0017,0x000b,0x0016,0x0009,0x0012,0x0001
};

/*********************************************************************/
/* Log table                                                         */
/*********************************************************************/
unsigned gflog[32] = {
/*    0 */ 0x003d,0x0000,0x0001,0x0012,0x0002,0x0005,0x0013,0x000b,
/*    8 */ 0x0003,0x001d,0x0006,0x001b,0x0014,0x0008,0x000c,0x0017,
/*   16 */ 0x0004,0x000a,0x001e,0x0011,0x0007,0x0016,0x001c,0x001a,
/*   24 */ 0x0015,0x0019,0x0009,0x0010,0x000d,0x000e,0x0018,0x000f
};

#define gfadd(x,y)    ((x)^(y))
#define gfmulnz(x,y)  (gfalog[(gflog[x]+gflog[y])%(31)])
#define gfmul(x,y)    (((x)*(y))?(gfmulnz(x,y)):(0))
#define gfinvnz(x)    (gfalog[31-gflog[x]])
#define gfinv(x)      ((x)?(gfinvnz(x)):(0))
#define gfpownz(x,k)  (gfalog[(((31)+(k)%(31))*gflog[x])%(31)])
#define gfpow(x, k)   ((x)?(gfpownz(x,k)):((k)?0:gfalog[0]))
